<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/getrandom-0.2.7/src/linux_android.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>linux_android.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="icon" href="https://www.rust-lang.org/favicon.ico"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../getrandom/index.html"><div class="logo-container"><img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk.png" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../getrandom/index.html"><div class="logo-container">
                    <img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk.png" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../getrandom/index.html">
                        <img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk.png" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
</pre><pre class="rust"><code><span class="comment">// Copyright 2018 Developers of the Rand project.</span>
<span class="comment">//</span>
<span class="comment">// Licensed under the Apache License, Version 2.0 &lt;LICENSE-APACHE or</span>
<span class="comment">// https://www.apache.org/licenses/LICENSE-2.0&gt; or the MIT license</span>
<span class="comment">// &lt;LICENSE-MIT or https://opensource.org/licenses/MIT&gt;, at your</span>
<span class="comment">// option. This file may not be copied, modified, or distributed</span>
<span class="comment">// except according to those terms.</span>

<span class="doccomment">//! Implementation for Linux / Android</span>
<span class="kw">use</span> <span class="kw">crate</span>::{
    <span class="ident">util::LazyBool</span>,
    <span class="ident">util_libc</span>::{<span class="ident">last_os_error</span>, <span class="ident">sys_fill_exact</span>},
    {<span class="ident">use_file</span>, <span class="ident">Error</span>},
};

<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">getrandom_inner</span>(<span class="ident">dest</span>: <span class="kw-2">&amp;mut</span> [<span class="ident">u8</span>]) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span>(), <span class="ident">Error</span><span class="op">&gt;</span> {
    <span class="comment">// getrandom(2) was introduced in Linux 3.17</span>
    <span class="kw">static</span> <span class="ident">HAS_GETRANDOM</span>: <span class="ident">LazyBool</span> <span class="op">=</span> <span class="ident">LazyBool::new</span>();
    <span class="kw">if</span> <span class="ident">HAS_GETRANDOM</span>.<span class="ident">unsync_init</span>(<span class="ident">is_getrandom_available</span>) {
        <span class="ident">sys_fill_exact</span>(<span class="ident">dest</span>, <span class="op">|</span><span class="ident">buf</span><span class="op">|</span> <span class="kw">unsafe</span> {
            <span class="ident">getrandom</span>(<span class="ident">buf</span>.<span class="ident">as_mut_ptr</span>() <span class="kw">as</span> <span class="kw-2">*mut</span> <span class="ident">libc::c_void</span>, <span class="ident">buf</span>.<span class="ident">len</span>(), <span class="number">0</span>)
        })
    } <span class="kw">else</span> {
        <span class="ident">use_file::getrandom_inner</span>(<span class="ident">dest</span>)
    }
}

<span class="kw">fn</span> <span class="ident">is_getrandom_available</span>() -&gt; <span class="ident">bool</span> {
    <span class="kw">let</span> <span class="ident">res</span> <span class="op">=</span> <span class="kw">unsafe</span> { <span class="ident">getrandom</span>(<span class="ident">core::ptr::null_mut</span>(), <span class="number">0</span>, <span class="ident">libc::GRND_NONBLOCK</span>) };
    <span class="kw">if</span> <span class="ident">res</span> <span class="op">&lt;</span> <span class="number">0</span> {
        <span class="kw">match</span> <span class="ident">last_os_error</span>().<span class="ident">raw_os_error</span>() {
            <span class="prelude-val">Some</span>(<span class="ident">libc::ENOSYS</span>) =&gt; <span class="bool-val">false</span>, <span class="comment">// No kernel support</span>
            <span class="prelude-val">Some</span>(<span class="ident">libc::EPERM</span>) =&gt; <span class="bool-val">false</span>,  <span class="comment">// Blocked by seccomp</span>
            <span class="kw">_</span> =&gt; <span class="bool-val">true</span>,
        }
    } <span class="kw">else</span> {
        <span class="bool-val">true</span>
    }
}

<span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">getrandom</span>(
    <span class="ident">buf</span>: <span class="kw-2">*mut</span> <span class="ident">libc::c_void</span>,
    <span class="ident">buflen</span>: <span class="ident">libc::size_t</span>,
    <span class="ident">flags</span>: <span class="ident">libc::c_uint</span>,
) -&gt; <span class="ident">libc::ssize_t</span> {
    <span class="ident">libc::syscall</span>(<span class="ident">libc::SYS_getrandom</span>, <span class="ident">buf</span>, <span class="ident">buflen</span>, <span class="ident">flags</span>) <span class="kw">as</span> <span class="ident">libc::ssize_t</span>
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="getrandom" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>